#ifdef __cplusplus
extern "C" {
#endif

#if !defined(__POWERPC__) && !defined(__CFM68K__)

	#define EnterCodeResource() long oldA4 = SetCurrentA4()
	#define ExitCodeResource() SetA4(oldA4)

	#define PrepareCallback() RememberA4() 
	#define EnterCallback() long oldA4 = SetUpA4()
	#define ExitCallback() RestoreA4(oldA4)

	void RememberA4(void);
	long SetUpA4(void);
	long RestoreA4(long:__D0):__D0 = 0xC18C;
	
	long SetCurrentA4(void);
	long SetA4(long:__D0):__D0 = 0xC18C;
	long GetCurrentA4(void) = 0x200C;
	
#else

	#define EnterCodeResource()
	#define ExitCodeResource()

	#define PrepareCallback() 
	#define EnterCallback()
	#define ExitCallback()
	
	#define RememberA4() 	0L
	#define SetUpA4() 		0L
	#define RestoreA4(x)	0L

	#define SetCurrentA4() 	0L
	#define SetA4(x)		0L
	#define GetCurrentA4() 	0L
	
#endif

#ifdef __cplusplus
}
#endif
